diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
index 4247cd617..f7a21a501 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelFluid.java
@@ -14,6 +14,7 @@ import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
+import org.joml.Math;
 import org.joml.primitives.AABBdc;
 
 public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStandard<T> {
@@ -23,13 +24,9 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
 
     @Override
     public boolean render(@NotNull TessellatorGeneral tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
-        int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(worldSource, tilePos, 0);
-        float r = (float) (color >> 16 & 0xff) / 255F;
-        float g = (float) (color >> 8 & 0xff) / 255F;
-        float b = (float) (color & 0xff) / 255F;
+        tessellator.setColor1i(BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(worldSource, tilePos, 0));
 
         TilePos queryPos = new TilePos();
-
         final int x = tilePos.x();
         final int y = tilePos.y();
         final int z = tilePos.z();
@@ -38,27 +35,22 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
 
         boolean renderTop = shouldSideBeRendered(worldSource, bounds, tilePos.up(queryPos), Side.TOP);
         boolean flag1 = shouldSideBeRendered(worldSource, bounds, tilePos.down(queryPos), Side.BOTTOM);
-        boolean[] aflag = new boolean[4];
-        aflag[0] = shouldSideBeRendered(worldSource, bounds, tilePos.north(queryPos), Side.NORTH);
-        aflag[1] = shouldSideBeRendered(worldSource, bounds, tilePos.south(queryPos), Side.SOUTH);
-        aflag[2] = shouldSideBeRendered(worldSource, bounds, tilePos.west(queryPos), Side.WEST);
-        aflag[3] = shouldSideBeRendered(worldSource, bounds, tilePos.east(queryPos), Side.EAST);
-        if (!renderTop && !flag1 && !aflag[0] && !aflag[1] && !aflag[2] && !aflag[3]) {
+        boolean[] sideRenderFlags = new boolean[4];
+        sideRenderFlags[0] = shouldSideBeRendered(worldSource, bounds, tilePos.north(queryPos), Side.NORTH);
+        sideRenderFlags[1] = shouldSideBeRendered(worldSource, bounds, tilePos.south(queryPos), Side.SOUTH);
+        sideRenderFlags[2] = shouldSideBeRendered(worldSource, bounds, tilePos.west(queryPos), Side.WEST);
+        sideRenderFlags[3] = shouldSideBeRendered(worldSource, bounds, tilePos.east(queryPos), Side.EAST);
+        if (!renderTop && !flag1 && !sideRenderFlags[0] && !sideRenderFlags[1] && !sideRenderFlags[2] && !sideRenderFlags[3]) {
             return false;
         }
         boolean didRender = false;
 
-        final float sideBottom = 0.5f;
-        final float sideTop = 1.0f;
-        final float sideNorthSouth = 0.8f;
-        final float sideEastWest = 0.6f;
-
         final float yOff = 0.001f;
         int meta = worldSource.getBlockData(tilePos);
-        float f7 = this.block.getLogic().getFluidHeight(worldSource, tilePos);
-        float f8 = this.block.getLogic().getFluidHeight(worldSource, tilePos.add(0, 0, 1, queryPos));
-        float f9 = this.block.getLogic().getFluidHeight(worldSource, tilePos.add(1, 0, 1, queryPos));
-        float f10 = this.block.getLogic().getFluidHeight(worldSource, tilePos.add(1, 0, 0, queryPos));
+        float h = this.block.getLogic().getFluidHeight(worldSource, tilePos);
+        float hs = this.block.getLogic().getFluidHeight(worldSource, tilePos.add(0, 0, 1, queryPos));
+        float hes = this.block.getLogic().getFluidHeight(worldSource, tilePos.add(1, 0, 1, queryPos));
+        float he = this.block.getLogic().getFluidHeight(worldSource, tilePos.add(1, 0, 0, queryPos));
         if (renderBlocks.renderAllFaces || renderTop) {
             didRender = true;
             IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.TOP, meta);
@@ -68,7 +60,6 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
             } else {
                 rotation = 0.0F;
             }
-            float blockBrightness = 1.0f;
             int light = this.block.getLightmapCoord(worldSource, tilePos);
             int lightUp = this.block.getLightmapCoord(worldSource, tilePos.up(queryPos));
 
@@ -76,33 +67,42 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
             if (texture.namespaceId.toString().contains("_flowing")) {
                 double centerU = texture.getSubIconU(0.5);
                 double centerV = texture.getSubIconV(0.5);
-                float cSin = MathHelper.cos(rotation) / 2;
-                float sin = MathHelper.sin(rotation) / 2;
+                float cSin = Math.cos(rotation) / 2;
+                float sin = Math.sin(rotation) / 2;
 
                 double minU = texture.getIconUMin();
                 double maxU = texture.getIconUMax();
                 double minV = texture.getIconVMin();
                 double maxV = texture.getIconVMax();
 
-                tessellator.setColorOpaque3f(sideTop * blockBrightness * r, sideTop * blockBrightness * g, sideTop * blockBrightness * b);
-                tessellator.addVertexWithUV(x, (float) y + f7, z, ((minU - centerU) * sin - (maxV - centerV) * cSin) + centerU, ((maxV - centerV) * sin + (minU - centerU) * cSin) + centerV);
-                tessellator.addVertexWithUV(x, (float) y + f8, z + 1, ((maxU - centerU) * sin - (maxV - centerV) * cSin) + centerU, ((maxV - centerV) * sin + (maxU - centerU) * cSin) + centerV);
-                tessellator.addVertexWithUV(x + 1, (float) y + f9, z + 1, ((maxU - centerU) * sin - (minV - centerV) * cSin) + centerU, ((minV - centerV) * sin + (maxU - centerU) * cSin) + centerV);
-                tessellator.addVertexWithUV(x + 1, (float) y + f10, z, ((minU - centerU) * sin - (minV - centerV) * cSin) + centerU, ((minV - centerV) * sin + (minU - centerU) * cSin) + centerV);
+                double du = (maxU - centerU);
+                double dv = (maxV - centerV);
+
+                tessellator.setNormal(0, 1, 0);
+                tessellator.addVertexWithUV(x, (float) y + h, z,
+                    Math.clamp(minU, maxU, -du * sin - dv * cSin + centerU),
+                    Math.clamp(minV, maxV, dv * sin + -du * cSin + centerV));
+                tessellator.addVertexWithUV(x, (float) y + hs, z + 1,
+                    Math.clamp(minU, maxU, du * sin - dv * cSin + centerU),
+                    Math.clamp(minV, maxV, dv * sin + du * cSin + centerV));
+                tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1,
+                    Math.clamp(minU, maxU, du * sin - (-dv) * cSin + centerU),
+                    Math.clamp(minV, maxV, -dv * sin + du * cSin + centerV));
+                tessellator.addVertexWithUV(x + 1, (float) y + he, z,
+                    Math.clamp(minU, maxU, -du * sin - (-dv) * cSin + centerU),
+                    Math.clamp(minV, maxV, -dv * sin + -du * cSin + centerV));
             } else {
-                tessellator.setColorOpaque3f(sideTop * blockBrightness * r, sideTop * blockBrightness * g, sideTop * blockBrightness * b);
-                tessellator.addVertexWithUV(x, (float) y + f7, z, texture.getIconUMin(), texture.getIconVMax());
-                tessellator.addVertexWithUV(x, (float) y + f8, z + 1, texture.getIconUMax(), texture.getIconVMax());
-                tessellator.addVertexWithUV(x + 1, (float) y + f9, z + 1, texture.getIconUMax(), texture.getIconVMin());
-                tessellator.addVertexWithUV(x + 1, (float) y + f10, z, texture.getIconUMin(), texture.getIconVMin());
+                tessellator.setNormal(0, 1, 0);
+                tessellator.addVertexWithUV(x, (float) y + h, z, texture.getIconUMin(), texture.getIconVMax());
+                tessellator.addVertexWithUV(x, (float) y + hs, z + 1, texture.getIconUMax(), texture.getIconVMax());
+                tessellator.addVertexWithUV(x + 1, (float) y + hes, z + 1, texture.getIconUMax(), texture.getIconVMin());
+                tessellator.addVertexWithUV(x + 1, (float) y + he, z, texture.getIconUMin(), texture.getIconVMin());
             }
 
         }
         if (renderBlocks.renderAllFaces || flag1) {
-            float brightness = 1.0f;
             tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, tilePos.down(queryPos)));
-            tessellator.setColorOpaque3f(sideBottom * brightness * r, sideBottom * brightness * g, sideBottom * brightness * b);
-
+            tessellator.setNormal(0, -1, 0);
             renderBlocks.renderBottomFace(tessellator, bounds, x, y + yOff, z, getBlockTextureFromSideAndMetadata(Side.TOP, 0));
             didRender = true;
         }
@@ -115,71 +115,69 @@ public class BlockModelFluid<T extends BlockLogicFluid> extends BlockModelStanda
                 case 2 -> posB.set(x - 1, y, z); // West
                 case 3 -> posB.set(x + 1, y, z); // East
             }
-            float uOff;
-            if (side == 0 || side == 1) {
-                uOff = (x & 1) == 0 ? 0.0f : 0.5f;
-            } else {
-                uOff = (z & 1) == 0 ? 0.0f : 0.5f;
-            }
             IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.getSideById(side + 2), meta);
-            if (!renderBlocks.renderAllFaces && !aflag[side]) {
+            if (!renderBlocks.renderAllFaces && !sideRenderFlags[side]) {
                 continue;
             }
             float f13;
             float f15;
-            float f17;
-            float f19;
-            float f20;
-            float f21;
-            if (side == 0) {
-                f13 = f7;
-                f15 = f10;
-                f17 = x + 0.0001f;
-                f20 = x + 1 - 0.0001f;
-                f19 = z + 0.0001f;
-                f21 = z + 0.0001f;
-            } else if (side == 1) {
-                f13 = f9;
-                f15 = f8;
-                f17 = x + 1 - 0.0001f;
-                f20 = x + 0.0001f;
-                f19 = z + 1 - 0.0001f;
-                f21 = z + 1 - 0.001f;
-            } else if (side == 2) {
-                f13 = f8;
-                f15 = f7;
-                f17 = x + 0.0001f;
-                f20 = x + 0.0001f;
-                f19 = z + 1 - 0.0001f;
-                f21 = z + 0.0001f;
-            } else {
-                f13 = f10;
-                f15 = f9;
-                f17 = x + 1 - 0.0001f;
-                f20 = x + 1 - 0.0001f;
-                f19 = z + 0.0001f;
-                f21 = z + 1 - 0.0001f;
+            float x1;
+            float z1;
+            float x2;
+            float z2;
+            switch (side) {
+                case 0 -> { // North
+                    f13 = h;
+                    f15 = he;
+                    x1 = x + 0.0001f;
+                    x2 = x + 1 - 0.0001f;
+                    z1 = z + 0.0001f;
+                    z2 = z + 0.0001f;
+                }
+                case 1 -> { // South
+                    f13 = hes;
+                    f15 = hs;
+                    x1 = x + 1 - 0.0001f;
+                    x2 = x + 0.0001f;
+                    z1 = z + 1 - 0.0001f;
+                    z2 = z + 1 - 0.001f;
+                }
+                case 2 -> { // West
+                    f13 = hs;
+                    f15 = h;
+                    x1 = x + 0.0001f;
+                    x2 = x + 0.0001f;
+                    z1 = z + 1 - 0.0001f;
+                    z2 = z + 0.0001f;
+                }
+                default -> { // East
+                    f13 = he;
+                    f15 = hes;
+                    x1 = x + 1 - 0.0001f;
+                    x2 = x + 1 - 0.0001f;
+                    z1 = z + 0.0001f;
+                    z2 = z + 1 - 0.0001f;
+                }
             }
             didRender = true;
-            float vOff = (y & 1) == 0 ? 0.0F : 0.5f;
-            double d4 = texture.getSubIconU(0.0F + uOff);
-            double d5 = texture.getSubIconU(0.5F + uOff);
-            double d6 = texture.getSubIconV(0.5F - f13 / 2 + vOff);
-            double d7 = texture.getSubIconV(0.5F - f15 / 2 + vOff);
-            double d8 = texture.getSubIconV(0.5F + vOff);
-            float brightness = 1.0f;
+            double u1 = texture.getSubIconU(0.0F);
+            double u2 = texture.getSubIconU(0.5F);
+            double v1 = texture.getSubIconV(0.5F - f13 / 2);
+            double v2 = texture.getSubIconV(0.5F - f15 / 2);
+            double v3 = texture.getSubIconV(0.5F);
             tessellator.setLightmapCoord1i(this.block.getLightmapCoord(worldSource, posB));
-            if (side < 2) {
-                brightness *= sideNorthSouth;
-            } else {
-                brightness *= sideEastWest;
+            switch (side) {
+                case 0 -> tessellator.setNormal(0, 0, -1);
+                case 1 -> tessellator.setNormal(0, 0, 1);
+                case 2 -> tessellator.setNormal(-1, 0, 0);
+                case 3 -> tessellator.setNormal(1, 0, 0);
             }
-            tessellator.setColorOpaque3f(sideTop * brightness * r, sideTop * brightness * g, sideTop * brightness * b);
-            tessellator.addVertexWithUV(f17, (float) y + f13, f19, d4, d6);
-            tessellator.addVertexWithUV(f20, (float) y + f15, f21, d5, d7);
-            tessellator.addVertexWithUV(f20, y, f21, d5, d8);
-            tessellator.addVertexWithUV(f17, y, f19, d4, d8);
+            tessellator.addVertexWithUV(x1, (float) y + f13, z1, u1, v1);
+            tessellator.addVertexWithUV(x2, (float) y + f15, z2, u2, v2);
+            tessellator.addVertexWithUV(x2, y, z2, u2, v3);
+            tessellator.addVertexWithUV(x1, y, z1, u1, v3);
         }
+        tessellator.setNormal(0, 1, 0);
         return didRender;
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java
index bf99e95e6..bd5d46a11 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererArrow.java
@@ -30,7 +30,6 @@ public class EntityRendererArrow extends EntityRenderer<ProjectileArrow> {
         float tailMaxV = (float) (10 + arrowType * 10) / 32F;
         float scale = 9F / 160F;
 
-//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         float shakeAmount = (float) arrow.shake - partialTick;
         if (shakeAmount > 0.0F) {
             float shakeAngle = -MathHelper.sin(shakeAmount * 3F) * shakeAmount;
@@ -41,7 +40,6 @@ public class EntityRendererArrow extends EntityRenderer<ProjectileArrow> {
         GLRenderer.modelM4f().rotateX(Math.toRadians(45f));
         GLRenderer.modelM4f().scale(scale, scale, scale);
         GLRenderer.modelM4f().translate(-4F, 0.0F, 0.0F);
-//        GL11.glNormal3f(scale, 0.0F, 0.0F);
 
         // Draw arrow tail
         tessellator.startDrawingQuads();
@@ -50,7 +48,6 @@ public class EntityRendererArrow extends EntityRenderer<ProjectileArrow> {
         tessellator.addVertexWithUV(-7D, 2D, 2D, tailMaxU, tailMaxV);
         tessellator.addVertexWithUV(-7D, 2D, -2D, tailMinU, tailMaxV);
         tessellator.draw();
-//        GL11.glNormal3f(-scale, 0.0F, 0.0F);
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(-7D, 2D, -2D, tailMinU, tailMinV);
         tessellator.addVertexWithUV(-7D, 2D, 2D, tailMaxU, tailMinV);
@@ -61,7 +58,6 @@ public class EntityRendererArrow extends EntityRenderer<ProjectileArrow> {
         // Draw arrow body
         for (int i = 0; i < 4; i++) {
             GLRenderer.modelM4f().rotateX(Math.PI_OVER_2_f);
-//            GL11.glNormal3f(0.0F, 0.0F, scale);
             tessellator.startDrawingQuads();
             tessellator.addVertexWithUV(-8D, -2D, 0.0D, bodyMinU, bodyMinV);
             tessellator.addVertexWithUV(8D, -2D, 0.0D, bodyMaxU, bodyMinV);
@@ -70,7 +66,6 @@ public class EntityRendererArrow extends EntityRenderer<ProjectileArrow> {
             tessellator.draw();
         }
 
-//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         GLRenderer.popFrame();
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
index 06c83cbdc..558acc8cc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererBoat.java
@@ -27,7 +27,6 @@ public class EntityRendererBoat extends EntityRenderer<EntityBoat> {
     @Override
     public void render(@NotNull final TessellatorGeneral tessellator, @NotNull final EntityBoat entity, final double x, final double y, final double z,
                        final float yaw, final float partialTick) {
-//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GLRenderer.pushFrame();
         GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
         GLRenderer.modelM4f().rotateY(Math.toRadians(180F - yaw));
@@ -59,9 +58,7 @@ public class EntityRendererBoat extends EntityRenderer<EntityBoat> {
         GLRenderer.modelM4f().scale(1.0F / f4, 1.0F / f4, 1.0F / f4);
         bindTexture("/assets/minecraft/textures/entity/boat.png");
         GLRenderer.modelM4f().scale(1 / 16f, 1 / 16f, -1 / 16f);
-//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         getModel("main").render();
         GLRenderer.popFrame();
-//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
index 0bc021248..b0c440bdb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFallingBlock.java
@@ -33,17 +33,13 @@ public class EntityRendererFallingBlock extends EntityRenderer<EntityFallingBloc
             this.container = new BlocksContainer(fallingBlock.world);
         }
         GLRenderer.pushFrame();
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+        GLRenderer.setLightmapCoord2f(15, 15);
         GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
         TextureRegistry.worldAtlas.bind();
-        Lighting.disable();
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         GLRenderer.enableState(State.BLEND);
         GLRenderer.disableState(State.CULL_FACE);
-//        if (this.mc.isAmbientOcclusionEnabled()) {
-//            GL11.glShadeModel(GL11.GL_SMOOTH);
-//        } else {
-//            GL11.glShadeModel(GL11.GL_FLAT);
-//        }
 
         TilePos blockPos = new TilePos(fallingBlock);
 
@@ -58,8 +54,6 @@ public class EntityRendererFallingBlock extends EntityRenderer<EntityFallingBloc
 
         tessellator.setTranslation(0.0D, 0.0D, 0.0D);
         tessellator.draw();
-
-        Lighting.enableLight();
         GLRenderer.popFrame();
 
         TileEntityRenderer<TileEntity> renderer = TileEntityRenderDispatcher.instance.getRenderer(fallingBlock.carriedBlock.entity);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
index 01795afdd..57a967328 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererFishingBobber.java
@@ -2,13 +2,13 @@ package net.minecraft.client.render.entity;
 
 import net.minecraft.client.render.renderer.DrawMode;
 import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.EntityFishingBobber;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.joml.Vector3d;
-import org.lwjgl.opengl.GL11;
 
 public class EntityRendererFishingBobber extends EntityRendererSprite<EntityFishingBobber> {
 
@@ -45,7 +45,8 @@ public class EntityRendererFishingBobber extends EntityRendererSprite<EntityFish
             double xa = (float) (xp - xh);
             double ya = (float) (yp - yh);
             double za = (float) (zp - zh);
-            GL11.glDisable(GL11.GL_TEXTURE_2D);
+            GLRenderer.pushFrame();
+            GLRenderer.setShader(Shaders.COLOR_WORLD);
             GLRenderer.globalSetLightEnabled(false);
             tessellator.startDrawing(DrawMode.LINE_STRIP);
             tessellator.setColorOpaque1i(0);
@@ -56,7 +57,7 @@ public class EntityRendererFishingBobber extends EntityRendererSprite<EntityFish
 
             tessellator.draw();
             GLRenderer.globalSetLightEnabled(true);
-            GL11.glEnable(GL11.GL_TEXTURE_2D);
+            GLRenderer.popFrame();
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
index 1d1294cab..96dc05415 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererLightningBolt.java
@@ -10,7 +10,6 @@ import net.minecraft.client.render.renderer.State;
 import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.entity.EntityLightning;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
 
 public class EntityRendererLightningBolt extends EntityRenderer<EntityLightning> {
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
index 7a37bb233..0c5c394ce 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererMinecart.java
@@ -21,7 +21,6 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
 
     @Override
     public void render(@NotNull final TessellatorGeneral tessellator, @NotNull final EntityMinecart minecart, final double x, final double y, final double z, final float yaw, final float partialTick) {
-//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GLRenderer.pushFrame();
 
         final double lerpX = MathHelper.lerp(minecart.xo, minecart.x, partialTick);
@@ -117,7 +116,6 @@ public class EntityRendererMinecart extends EntityRenderer<EntityMinecart> {
         GLRenderer.modelM4f().scale(1 / 16f, 1 / 16f, -1 / 16f);
         getModel("main").render();
         GLRenderer.popFrame();
-//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
     }
 
     private static void drawDebugVec(final @NotNull TessellatorGeneral tessellator, final @NotNull Vector3dc start, final @NotNull Vector3dc end, final double scale, final float r, final float g, final float b, final float a) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
index cb0ba48cd..97d384fdf 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererPainting.java
@@ -124,7 +124,6 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting> {
         GLRenderer.pushFrame();
         GLRenderer.modelM4f().translate((float) x, (float) y, (float) z);
         GLRenderer.modelM4f().rotateY(Math.toRadians(yaw));
-//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         ArtType art = entity.art;
         float scale = 0.0625F;
         GLRenderer.modelM4f().scale(scale, scale, scale);
@@ -138,7 +137,6 @@ public class EntityRendererPainting extends EntityRenderer<EntityPainting> {
             renderBorder(entity, entity.art.sizeX, entity.art.sizeY);
             GLRenderer.disableState(State.BLEND);
         }
-//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         GLRenderer.popFrame();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
index 579c03eeb..76e82e574 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/EntityRendererSprite.java
@@ -43,7 +43,6 @@ public class EntityRendererSprite<T extends Entity> extends EntityRenderer<T> {
             GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             GLRenderer.setLightmapCoord1i(LightmapHelper.getLightmapCoord(15, 15));
         }
-//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GLRenderer.modelM4f().scale(0.5F * this.scale, 0.5F * this.scale, 0.5F * this.scale);
         this.itemIconIndex.parentAtlas.bind();
         float f2 = (float) this.itemIconIndex.getIconUMin();
@@ -62,7 +61,6 @@ public class EntityRendererSprite<T extends Entity> extends EntityRenderer<T> {
         tessellator.addVertexWithUV(f6 - f7, 1.0F - f8, 0.0D, f3, f4);
         tessellator.addVertexWithUV(0.0F - f7, 1.0F - f8, 0.0D, f2, f4);
         tessellator.draw();
-//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         GLRenderer.popFrame();
         if (this.fullBright) {
             GLRenderer.globalSetLightEnabled(true);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
index 89fca765b..448fec596 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRenderer.java
@@ -35,8 +35,6 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
     @Override
     public void render(final @NotNull TessellatorGeneral tessellator, final @NotNull T entity, final double x, final double y, final double z, final float yaw, final float partialTick) {
         loadEntityTexture(entity);
-//        bindTexture("/assets/minecraft/textures/entity/creeper/debug.png");
-//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
         GLRenderer.enableState(State.BLEND);
         GLRenderer.disableState(State.CULL_FACE);
@@ -60,14 +58,12 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
             }
         }
         renderAdditional(tessellator, entity, partialTick);
-//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
         final int argb = getOverlayColor(entity, 1f, partialTick);
         final boolean hasOverlayAlpha = Color.alphaFromInt(argb) > 0;
         if (hasOverlayAlpha || entity.hurtTime > 0 || entity.deathTime > 0) {
             GLRenderer.pushFrame();
             GLRenderer.setShader(Shaders.COLOR_WORLD);
-//            GL11.glDisable(GL11.GL_ALPHA_TEST);
             GLRenderer.enableState(State.BLEND);
             GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
             GLRenderer.setDepthFunc(CompareFunc.EQUAL);
@@ -96,7 +92,6 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
             }
             GLRenderer.setDepthFunc(CompareFunc.LESS_EQUAL);
             GLRenderer.disableState(State.BLEND);
-//            GL11.glEnable(GL11.GL_ALPHA_TEST);
             GLRenderer.popFrame();
         }
 
@@ -104,7 +99,6 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
 
         GLRenderer.enableState(State.CULL_FACE);
         GLRenderer.disableState(State.BLEND);
-//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         renderSpecials(tessellator, entity, x, y, z);
     }
 
@@ -185,7 +179,6 @@ public abstract class MobRenderer<T extends Mob> extends EntityRenderer<T> {
 
         GLRenderer.pushFrame();
         GLRenderer.modelM4f().translate((float) x, (float) y + entity.getHeadHeight() + 0.8f, (float) z);
-//        GL11.glNormal3f(0.0F, 1.0F, 0.0F);
         GLRenderer.modelM4f().rotateY(Math.toRadians(-this.renderDispatcher.viewLerpYaw));
         GLRenderer.modelM4f().rotateX(Math.toRadians(this.renderDispatcher.viewLerpPitch));
         GLRenderer.modelM4f().scale(-scale, -scale, scale);
diff --git a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
index f6b94890b..e5b64674c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/entity/MobRendererButterfly.java
@@ -34,7 +34,6 @@ public class MobRendererButterfly extends EntityRenderer<MobButterfly> {
         textureManager.bindTexture(textureManager.loadTexture(texture));
         GLRenderer.pushFrame();
         GLRenderer.modelM4f().translate((float) x, (float) y + 0.25f, (float) z);
-//        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         GLRenderer.disableState(State.CULL_FACE);
         GLRenderer.globalSetLightEnabled(false);
         GLRenderer.modelM4f().scale(0.5F * scale, 0.5F * scale, 0.5F * scale);
@@ -68,7 +67,6 @@ public class MobRendererButterfly extends EntityRenderer<MobButterfly> {
         tessellator.draw();
         GLRenderer.popFrame();
 
-//        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
         GLRenderer.enableState(State.CULL_FACE);
         GLRenderer.globalSetLightEnabled(true);
         GLRenderer.popFrame();
